# users generic .bash_profile file read by login shell of bash(1)
#
# Copyright (c) 2006 Daichi GOTO <daichi@ongs.co.jp>
# Copyright (c) 2006 ONGS Inc. <info@ongs.co.jp>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
# THE POSSIBILITY OF SUCH DAMAGE.

# author: Daichi GOTO (daichi@ongs.co.jp)
# first edition: Fri Apr  7 19:37:54 2006
# last modified: $Date: 2006/12/25 07:32:35 $
# version: $Revision: 1.8 $

# bash(1) reads configuration files logining orderly as follow:
# 
#  1. ~/.bash_profile
#  2. ~/.bash_login   (if it does not have ~/.bash_profile file)
#  3. ~/.bashrc       (if it hoes not have both ~/.bash_profile and 
#                      ~/.bash_login files)



## load user .profile configuration file
#
[ -f ~/.profile ] && . ~/.profile


## load user .bash_profile.mine configuration file
#
[ -f ~/.bash_profile.mine ] && . ~/.bash_profile.mine


## load .bashrc configuration file
#
[ -f ~/.bashrc ] && . ~/.bashrc


## Startup X Window System if user set it and this is X-able login shell
#
[ NO != ${XSTARTUP-NO} -a NO = ${REMOTEHOST-NO} ] &&
  [ NO = ${SSH_CONNECTION-NO} -a -f /etc/X11/xorg.conf ] &&
    type xinit > /dev/null 2>&1 && xinit
