" users generic .vimrc file for vim(1)
"
" Copyright (c) 2001-2004 Daichi GOTO <daichi@ongs.co.jp>
" Copyright (c) 2006 ONGS Inc. <info@ongs.co.jp>
" All rights reserved.
" 
" Redistribution and use in source and binary forms, with or without
" modification, are permitted provided that the following conditions
" are met:
" 
" 1. Redistributions of source code must retain the above copyright 
"    notice, this list of conditions and the following disclaimer. 
" 2. Redistributions in binary form must reproduce the above copyright 
"    notice, this list of conditions and the following disclaimer in the 
"    documentation and/or other materials provided with the distribution.
" 
" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
" PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS
" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
" IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
" THE POSSIBILITY OF SUCH DAMAGE.

" author: Daichi GOTO (daichi@ongs.co.jp)
" first edition: Fri May 17 12:31:53 JST 2002
" last modified: $Date: 2006/05/16 14:14:35 $
" version: $Revision: 1.11 $

" When started as "evim", evim.vim will already have done these configuration.
if v:progname =~? "evim"
  finish
endif

" Use Vim configurations, rather then Vi's one.
set nocompatible

" allow backspacing over everything in insert mode
set backspace=indent,eol,start

" keep 50 lines of command line history
set history=50

" show the cursor position all the time
set ruler

" display incomplete commands
set showcmd

" do incremental searching
set incsearch

" do syntax highlight
syntax on
set hlsearch

" set background color and text colorn (for black display)
if "cons25" == $TERM
    hi Normal ctermbg=black ctermfg=white
endif

" do file encoding auto check
set fileencodings=utf8,iso-2022-jp,euc-jp,sjis
